<?php

require_once dirname(__FILE__).'/../lib/uslg_specjalistaGeneratorConfiguration.class.php';
require_once dirname(__FILE__).'/../lib/uslg_specjalistaGeneratorHelper.class.php';

/**
 * uslg_specjalista actions.
 *
 * @package    ##PROJECT_NAME##
 * @subpackage uslg_specjalista
 * @author     ##AUTHOR_NAME##
 */
class uslg_specjalistaActions extends sfActions
{

    public function preExecute()
    {
        $this->configuration = new uslg_specjalistaGeneratorConfiguration();

        if(!$this->getUser()->hasCredential($this->configuration->getCredentials($this->getActionName())))
        {
            $this->forward(sfConfig::get('sf_secure_module'), sfConfig::get('sf_secure_action'));
        }

        $this->dispatcher->notify(new sfEvent($this, 'admin.pre_execute', array('configuration' => $this->configuration)));

        $this->helper = new uslg_specjalistaGeneratorHelper();
    }

    public function executeIndex(sfWebRequest $request)
    {
        // sorting
        if($request->getParameter('sort') && $this->isValidSortColumn($request->getParameter('sort')))
        {
            $this->setSort(array($request->getParameter('sort'), $request->getParameter('sort_type')));
        }

        // pager
        if($request->getParameter('page'))
        {
            $this->setPage($request->getParameter('page'));
        }

        $this->pager = $this->getPager();
        $this->sort = $this->getSort();
    }

    public function executeFilter(sfWebRequest $request)
    {
        $this->setPage(1);

        if($request->hasParameter('_reset'))
        {
            $this->setFilters($this->configuration->getFilterDefaults());

            $this->redirect('@baza_uslug_specjalista');
        }

        $this->filters = $this->configuration->getFilterForm($this->getFilters());

        $this->filters->bind($request->getParameter($this->filters->getName()));
        if($this->filters->isValid())
        {
            $this->setFilters($this->filters->getValues());

            $this->redirect('@baza_uslug_specjalista');
        }

        $this->pager = $this->getPager();
        $this->sort = $this->getSort();

        $this->setTemplate('index');
    }

    public function executeNew(sfWebRequest $request)
    {
        if(is_null($this->filters))
            $this->filters = $this->configuration->getFilterForm($this->getFilters());

        $this->form = $this->configuration->getForm();
        $this->baza_uslug_specjalista = $this->form->getObject();
    }

    public function executeCreate(sfWebRequest $request)
    {
        if(is_null($this->filters))
            $this->filters = $this->configuration->getFilterForm($this->getFilters());

        $this->form = $this->configuration->getForm();
        $this->baza_uslug_specjalista = $this->form->getObject();

        $this->processForm($request, $this->form);

        $this->setTemplate('new');
    }

    public function executeEdit(sfWebRequest $request)
    {
        if(is_null($this->filters))
            $this->filters = $this->configuration->getFilterForm($this->getFilters());

        $this->baza_uslug_specjalista = $this->getRoute()->getObject();
        $this->form = $this->configuration->getForm($this->baza_uslug_specjalista);
    }

    public function executeUpdate(sfWebRequest $request)
    {
        if(is_null($this->filters))
            $this->filters = $this->configuration->getFilterForm($this->getFilters());

        $this->baza_uslug_specjalista = $this->getRoute()->getObject();
        $this->form = $this->configuration->getForm($this->baza_uslug_specjalista);

        $this->processForm($request, $this->form);

        $this->setTemplate('edit');
    }

    public function executeDelete(sfWebRequest $request)
    {
        $request->checkCSRFProtection();

        $this->dispatcher->notify(new sfEvent($this, 'admin.delete_object', array('object' => $this->getRoute()->getObject())));

        $this->getRoute()->getObject()->delete();

        $this->getUser()->setFlash('notice', 'The item was deleted successfully.');

        $this->redirect('@baza_uslug_specjalista');
    }

    public function executeBatch(sfWebRequest $request)
    {
        $request->checkCSRFProtection();

        if(!$ids = $request->getParameter('ids'))
        {
            $this->getUser()->setFlash('error', 'You must at least select one item.');

            $this->redirect('@baza_uslug_specjalista');
        }

        if(!$action = $request->getParameter('batch_action'))
        {
            $this->getUser()->setFlash('error', 'You must select an action to execute on the selected items.');

            $this->redirect('@baza_uslug_specjalista');
        }

        if(!method_exists($this, $method = 'execute'.ucfirst($action)))
        {
            throw new InvalidArgumentException(sprintf('You must create a "%s" method for action "%s"', $method, $action));
        }

        if(!$this->getUser()->hasCredential($this->configuration->getCredentials($action)))
        {
            $this->forward(sfConfig::get('sf_secure_module'), sfConfig::get('sf_secure_action'));
        }

        $validator = new sfValidatorPropelChoiceMany(array('model' => 'BazaUslugSpecjalista'));
        try
        {
            // validate ids
            $ids = $validator->clean($ids);

            // execute batch
            $this->$method($request);
        }
        catch (sfValidatorError $e)
        {
            $this->getUser()->setFlash('error', 'A problem occurs when deleting the selected items as some items do not exist anymore.');
        }

        $this->redirect('@baza_uslug_specjalista');
    }

    protected function executeBatchDelete(sfWebRequest $request)
    {
        $ids = $request->getParameter('ids');

        $count = 0;
        foreach(BazaUslugSpecjalistaPeer::retrieveByPks($ids) as $object)
        {
            $this->dispatcher->notify(new sfEvent($this, 'admin.delete_object', array('object' => $object)));

            $object->delete();
            if($object->isDeleted())
            {
                $count++;
            }
        }

        if($count >= count($ids))
        {
            $this->getUser()->setFlash('notice', 'The selected items have been deleted successfully.');
        }
        else
        {
            $this->getUser()->setFlash('error', 'A problem occurs when deleting the selected items.');
        }

        $this->redirect('@baza_uslug_specjalista');
    }

    protected function executeBatchPublicate(sfWebRequest $request)
    {
        $ids = $request->getParameter('ids');

        $count = 0;
        foreach(BazaUslugSpecjalistaPeer::retrieveByPks($ids) as $object)
        {
            $object->publicate();
            $count++;
        }

        if($count >= count($ids))
        {
            $this->getUser()->setFlash('notice', 'Wybrani specjaliści zostali opublikowani poprawnie');
        }
        else
        {
            $this->getUser()->setFlash('error', 'Wystąpił błąd podczas publikacji wybranych specjalistów');
        }

        $this->redirect('@baza_uslug_specjalista');
    }

    protected function executeBatchHide(sfWebRequest $request)
    {
        $ids = $request->getParameter('ids');

        $count = 0;
        foreach(BazaUslugSpecjalistaPeer::retrieveByPks($ids) as $object)
        {
            $object->hide();
            $count++;
        }

        if($count >= count($ids))
        {
            $this->getUser()->setFlash('notice', 'Wybrane usługi zostały ukryte poprawnie');
        }
        else
        {
            $this->getUser()->setFlash('error', 'Wystąpił błąd podczas ukrywania wybranych usług');
        }

        $this->redirect('@baza_uslug_usluga');
    }

    protected function processForm(sfWebRequest $request, sfForm $form)
    {
        // preset - debug-mode:
        $debug = false; //preg_match('`dev.php`', $_SERVER['SCRIPT_NAME']);

        sfContext::getInstance()->getConfiguration()->loadHelpers(array('I18N'));

        $params = $request->getParameter($form->getName(), array());
        $files = $request->getFiles($form->getName(), array());

        if($debug)
        {
            print_r('<pre><h2>PARAMS:</h2> ').print_r($params).print_r('</pre>');
            print_r('<pre><h2>FILES:</h2> ').print_r($files).print_r('</pre>');
        }

        $form->bind($params, $files);
        if($form->isValid())
        {
            
            $notice = $form->getObject()->isNew() ? __('The item was created successfully.') : __('The item was updated successfully.');
            $file = $this->form->getValue('grafika_zajawki');
            if(!$form->getObject()->isNew())
            {
                $old_record = BazaUslugSpecjalistaPeer::retrieveByPK($form->getObject()->getId());
                if($old_record)
                    $gfx = $old_record->getGrafikaZajawki();
            }

            $baza_uslug_specjalista = $form->save();
            
            @mkdir(sfConfig::get('sf_upload_dir').'/baza_uslug/spec_'.$baza_uslug_specjalista->getId().'/thumbnails/', 0777, true);
        
            //Usunięcie grafiki zajawkowej
            if(!empty($gfx) && ((array_key_exists('grafika_zajawki_delete', $params) && $params['grafika_zajawki_delete'] == 'on') || !empty($file)))
            {
                $path_file = sfConfig::get('sf_upload_dir').'/baz_uslug/spec_'.$baza_uslug_specjalista->getId().'/';
                
                //kasuje zuploadowana zajwke grafiki
                if(is_file($path_file.$gfx))
                    unlink($path_file.$gfx);

                //kasuje pomiejszone wersje grafiki zajawki
                $path_thumbnails = sfConfig::get('sf_upload_dir').'/baza_uslug/spec_'.$baza_uslug_specjalista->getId().'/thumbnails/';
                if(is_file($path_thumbnails.'mini_'.$gfx))
                    unlink($path_thumbnails.'mini_'.$gfx);
                if(is_file($path_thumbnails.'thumb_'.$gfx))
                    unlink($path_thumbnails.'thumb_'.$gfx);
                if(is_file($path_thumbnails.'normal_'.$gfx))
                    unlink($path_thumbnails.'normal_'.$gfx);

                $baza_uslug_specjalista->setGrafikaZajawki(null);
                $baza_uslug_specjalista->save();

                if($debug)
                    print_r('<pre><h2>').print_r('Kasowanie katalogu grafiki zajawki').print_r('</h2></pre>');
            }

            //Generowanie zajawki z usuwaniem niepotrzebnych tagow
            $dlugosc_zajawki = 255;
            if($debug)
                print_r('<pre><h2>JĘZYKI:</h2>').print_r('</pre>');
            foreach(JezykTblPeer::getCulturesForModul('uslg') as $culture)
            {
                $i18n = $baza_uslug_specjalista->getCurrentBazaUslugSpecjalistaI18n($culture);

                //Ustawienie odpowiendich sciezek w tekscie
                //w TinyMCE.init() ustawione relative_urls: true wiec nie powinno byc zadnych problemow ze sciezkami
                //TinyMCE nie dorzuca poczatkowego slasha trzeba dodac recznie tak jak ponizej
                if($params[$culture]['opis'])
                    $i18n->setOpis(str_replace('"uploads/', '"/uploads/', $params[$culture]['opis']));

                $zajawka = trim(strip_tags($params[$culture]['zajawka']));
                $opis = $i18n->getOpis();

                //$zajawka = trim($baza_uslug_specjalista->getZajawka());
                if(empty($zajawka))
                {
                    $zajawka = Functions::generujSkrotTekstu($opis, $dlugosc_zajawki);
                    $i18n->setZajawka($zajawka);
                }
                else
                    $i18n->setZajawka($zajawka);

                $i18n->save();

                if($debug)
                    print_r('<pre><h3>Język `'.$culture.'` - zajawka:</h3> ').print_r($i18n->getZajawka()).print_r('</pre>');
            }

            try
            {
                if(!empty($file))
                {
                    $filename = sha1($file->getOriginalName()).$file->getExtension($file->getOriginalExtension());
                    $file->save(sfConfig::get('sf_upload_dir').'/baza_uslug/spec_'.$baza_uslug_specjalista->getId().'/'.$filename);
                    $count = Functions::wygenerujMiniaturkiPrzyUploadzie(sfConfig::get('sf_upload_dir').'/baza_uslug/spec_'.$baza_uslug_specjalista->getId().'/', $filename, './thumbnails/');
                    $baza_uslug_specjalista->setGrafikaZajawki($filename);
                    $baza_uslug_specjalista->save();
                    $this->getUser()->setFlash('info', __('Wygenerowano miniaturki ('.$count.')'));
                }
            }
            catch (Exception $e)
            {
                $this->getUser()->setFlash('error', $e->getMessage());
                $this->redirect(array('sf_route' => 'baza_uslug_specjalista_edit', 'sf_subject' => $baza_uslug_specjalista));
            }

            $this->dispatcher->notify(new sfEvent($this, 'admin.save_object', array('object' => $baza_uslug_specjalista)));

            if($request->hasParameter('_save_and_add'))
            {
                $this->getUser()->setFlash('notice', $notice.' You can add another one below.');

                $this->redirect('@baza_uslug_specjalista_new');
            }
            else
            {
                if($debug)
                    exit($notice);

                $this->getUser()->setFlash('notice', $notice);
                $this->redirect(array('sf_route' => 'baza_uslug_specjalista_edit', 'sf_subject' => $baza_uslug_specjalista));
            }
        }
        else
        {
            if($debug)
                exit('FORM INVALID');

            $this->getUser()->setFlash('error', __('The item has not been saved due to some errors.'), false);
        }
    }

    protected function getFilters()
    {
        return $this->getUser()->getAttribute('uslg_specjalista.filters', $this->configuration->getFilterDefaults(), 'admin_module');
    }

    protected function setFilters(array $filters)
    {
        return $this->getUser()->setAttribute('uslg_specjalista.filters', $filters, 'admin_module');
    }

    protected function getPager()
    {
        $pager = $this->configuration->getPager('BazaUslugSpecjalista');
        $pager->setCriteria($this->buildCriteria());
        $pager->setPage($this->getPage());
        $pager->setPeerMethod($this->configuration->getPeerMethod());
        $pager->setPeerCountMethod($this->configuration->getPeerCountMethod());
        $pager->init();

        return $pager;
    }

    protected function setPage($page)
    {
        $this->getUser()->setAttribute('uslg_specjalista.page', $page, 'admin_module');
    }

    protected function getPage()
    {
        return $this->getUser()->getAttribute('uslg_specjalista.page', 1, 'admin_module');
    }

    protected function buildCriteria()
    {
        if(is_null($this->filters))
        {
            $this->filters = $this->configuration->getFilterForm($this->getFilters());
        }

        $criteria = $this->filters->buildCriteria($this->getFilters());

        $this->addSortCriteria($criteria);

        $event = $this->dispatcher->filter(new sfEvent($this, 'admin.build_criteria'), $criteria);
        $criteria = $event->getReturnValue();

        return $criteria;
    }

    protected function addSortCriteria($criteria)
    {
        if(array(null, null) == ($sort = $this->getSort()))
        {
            return;
        }

        if($sort[0] == 'nazwa')
        {
            $culture = $this->getUser()->getCulture();
            $criteria->addJoin(BazaUslugSpecjalistaPeer::ID, BazaUslugSpecjalistaI18nPeer::ID, Criteria::LEFT_JOIN);
            $criteria->add(BazaUslugSpecjalistaI18nPeer::CULTURE, $culture);
            if('asc' == $sort[1])
                $criteria->addAscendingOrderByColumn(BazaUslugSpecjalistaI18nPeer::NAZWA);
            else
                $criteria->addDescendingOrderByColumn(BazaUslugSpecjalistaI18nPeer::NAZWA);

            return;
        }

        $column = BazaUslugSpecjalistaPeer::translateFieldName($sort[0], BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_COLNAME);
        if('asc' == $sort[1])
        {
            $criteria->addAscendingOrderByColumn($column);
        }
        else
        {
            $criteria->addDescendingOrderByColumn($column);
        }
    }

    protected function getSort()
    {
        if(!is_null($sort = $this->getUser()->getAttribute('uslg_specjalista.sort', null, 'admin_module')))
        {
            return $sort;
        }

        $this->setSort($this->configuration->getDefaultSort());

        return $this->getUser()->getAttribute('uslg_specjalista.sort', null, 'admin_module');
    }

    protected function setSort(array $sort)
    {
        if(!is_null($sort[0]) && is_null($sort[1]))
        {
            $sort[1] = 'asc';
        }

        $this->getUser()->setAttribute('uslg_specjalista.sort', $sort, 'admin_module');
    }

    protected function isValidSortColumn($column)
    {
        return in_array($column, BasePeer::getFieldnames('BazaUslugSpecjalista', BasePeer::TYPE_FIELDNAME)) || $column == 'nazwa';
    }

    public function executeThumbnailSave(sfWebRequest $request)
    {
        if(!$request->isMethod('post'))
            exit('Niedozwolona operacja');

        $this->forward404Unless($nazwa = $request->getParameter('filename', null), 'Brak wymaganego parametru `filename`.');
        $this->forward404Unless($size = $request->getParameter('size', null), 'Brak wymaganego parametru `size`.');
        $repl = sfConfig::get('sf_upload_dir');

        $preg_pattern = "/(.*)uploads/";
        $filename = preg_replace($preg_pattern, $repl, $nazwa);

        $id = null;
        if(preg_match('#spec_([0-9]+)#', $filename, $matches) && isset($matches[1]))
            $id = array_pop($matches);

        $thumb = str_replace('spec_'.$id.'/', 'spec_'.$id.'/thumbnails/'.$size.'_', $filename);
        
        $t_file = fopen($thumb, 'wb');
        fwrite($t_file, $GLOBALS["HTTP_RAW_POST_DATA"]);
        fclose($t_file);

        $watermark_config = UstawieniePeer::getProperties('graf_config_watermark');
        if(isset($watermark_config['show']) && $watermark_config['show'] == 1)
        {
            //znak wodny
            $margin = $watermark_config['margin'];
            $pos = $watermark_config['pos'];
            $watermark_src = sfConfig::get('sf_upload_dir')."/".$watermark_config['file'];
            UploadFileForm::addWatermark($thumb, $watermark_src, null, $pos, $margin);
        }
        exit;
    }

}
