<?php include_stylesheets_for_form($form) ?>
<?php include_javascripts_for_form($form) ?>

<div class="sf_admin_form">
    <?php echo form_tag_for($form, '@baza_uslug_specjalista', array('name' => 'uslg_specjalista_form', 'multipart' => true)) ?>
    <?php echo $form->renderHiddenFields() ?>

    <?php if($form->hasGlobalErrors()): ?>
        <?php echo $form->renderGlobalErrors() ?>
    <?php endif; ?>

    <?php
    // tresci jezykowe traktujemy osobno - tniemy na zakladki
    $lang_tabs = array();
    $cultures = JezykTblPeer::getCulturesForModul('uslg');
    $fieldsets = $configuration->getFormFields($form, $form->isNew() ? 'new' : 'edit');
    foreach($fieldsets as $fieldset => $fields)
    {
        foreach($fields as $name => $field)
        {
            if(in_array($name, $cultures))
            {
                $lang_tabs[$name] = $field;
                unset($fieldsets[$fieldset][$name]);
            }
        }
    }
    ?>

    <fieldset class="editor">
        <ul class="info_tabs" id="tab-container-nav">
            <?php
            $langs = array_keys($lang_tabs);
            for($i = 0; $i < sizeof($langs); $i++)
            {
                ?>
                <li <?php if($i == 0) echo 'class="sel"'; ?>>
                    <a href="#tab_<?php echo $i; ?>">
                        <?php echo image_tag('admin/lang_icons/ico_'.$langs[$i].'.gif', array('alt' => 'ikona', 'style' => 'width:15px; margin: 0px 4px 0px 0px; border: none;')); ?>
                        <?php echo strtoupper($langs[$i]); ?>
                    </a>
                </li>
            <?php } ?>
        </ul>


        <div id="tab-container">
            <?php
            $j = 0;
            foreach($lang_tabs as $name => $field)
            {
                echo '<div class="tab" id="tab_'.$j.'">';
                include_partial('uslg_specjalista/form_field', array(
                    'name' => $name,
                    'attributes' => $field->getConfig('attributes', array()),
                    'label' => $field->getConfig('label'),
                    'help' => $field->getConfig('help'),
                    'form' => $form,
                    'field' => $field,
                    'class' => 'sf_admin_form_row sf_admin_'.strtolower($field->getType()).' sf_admin_form_field_'.$name,
                ));
                
                echo '</div>';
            }
            ?>
        </div>
    </fieldset>

    <?php javascript_tag() ?>
    var tabber = new Yetii({ id: 'tab-container', tabclass:'tab' });
    jQuery('#tab-container > div.tab > b').remove();    
    <?php end_javascript_tag() ?>

    <?php foreach($fieldsets as $fieldset => $fields): ?>
        <?php include_partial('uslg_specjalista/form_fieldset', array('baza_uslug_specjalista' => $baza_uslug_specjalista, 'form' => $form, 'fields' => $fields, 'fieldset' => $fieldset)) ?>
    <?php endforeach; ?>

    <div style="float: right">
        <?php include_partial('uslg_specjalista/form_actions', array('baza_uslug_specjalista' => $baza_uslug_specjalista, 'form' => $form, 'configuration' => $configuration, 'helper' => $helper)) ?>
    </div>
    <?php echo '</form>'; ?>
</div>
