<?php

require_once dirname(__FILE__).'/../lib/uslg_uslugaGeneratorConfiguration.class.php';
require_once dirname(__FILE__).'/../lib/uslg_uslugaGeneratorHelper.class.php';

/**
 * uslg_usluga actions.
 *
 * @package    ##PROJECT_NAME##
 * @subpackage uslg_usluga
 * @author     ##AUTHOR_NAME##
 */
class uslg_uslugaActions extends sfActions
{

    public function preExecute()
    {
        $this->configuration = new uslg_uslugaGeneratorConfiguration();

        if(!$this->getUser()->hasCredential($this->configuration->getCredentials($this->getActionName())))
        {
            $this->forward(sfConfig::get('sf_secure_module'), sfConfig::get('sf_secure_action'));
        }

        $this->dispatcher->notify(new sfEvent($this, 'admin.pre_execute', array('configuration' => $this->configuration)));

        $this->helper = new uslg_uslugaGeneratorHelper();
    }

    public function executeIndex(sfWebRequest $request)
    {
        // sorting
        if($request->getParameter('sort') && $this->isValidSortColumn($request->getParameter('sort')))
        {
            $this->setSort(array($request->getParameter('sort'), $request->getParameter('sort_type')));
        }

        // pager
        if($request->getParameter('page'))
        {
            $this->setPage($request->getParameter('page'));
        }

        $this->pager = $this->getPager();
        $this->sort = $this->getSort();
    }

    public function executeFilter(sfWebRequest $request)
    {
        $this->setPage(1);

        if($request->hasParameter('_reset'))
        {
            $this->setFilters($this->configuration->getFilterDefaults());

            $this->redirect('@baza_uslug_usluga');
        }

        $this->filters = $this->configuration->getFilterForm($this->getFilters());

        $this->filters->bind($request->getParameter($this->filters->getName()));
        if($this->filters->isValid())
        {
            $this->setFilters($this->filters->getValues());

            $this->redirect('@baza_uslug_usluga');
        }

        $this->pager = $this->getPager();
        $this->sort = $this->getSort();

        $this->setTemplate('index');
    }

    public function executeNew(sfWebRequest $request)
    {
        if(is_null($this->filters))
            $this->filters = $this->configuration->getFilterForm($this->getFilters());
        
        $this->form = $this->configuration->getForm();
        $this->baza_uslug_usluga = $this->form->getObject();
    }

    public function executeCreate(sfWebRequest $request)
    {
        if(is_null($this->filters))
            $this->filters = $this->configuration->getFilterForm($this->getFilters());
        
        $this->form = $this->configuration->getForm();
        $this->baza_uslug_usluga = $this->form->getObject();

        $this->processForm($request, $this->form);

        $this->setTemplate('new');
    }

    public function executeEdit(sfWebRequest $request)
    {
        if(is_null($this->filters))
            $this->filters = $this->configuration->getFilterForm($this->getFilters());
        
        $this->baza_uslug_usluga = $this->getRoute()->getObject();
        $this->form = $this->configuration->getForm($this->baza_uslug_usluga);
    }

    public function executeUpdate(sfWebRequest $request)
    {
        if(is_null($this->filters))
            $this->filters = $this->configuration->getFilterForm($this->getFilters());
        
        $this->baza_uslug_usluga = $this->getRoute()->getObject();
        $this->form = $this->configuration->getForm($this->baza_uslug_usluga);

        $this->processForm($request, $this->form);

        $this->setTemplate('edit');
    }

    public function executeDelete(sfWebRequest $request)
    {
        $request->checkCSRFProtection();

        $this->dispatcher->notify(new sfEvent($this, 'admin.delete_object', array('object' => $this->getRoute()->getObject())));

        $this->getRoute()->getObject()->delete();

        $this->getUser()->setFlash('notice', 'The item was deleted successfully.');

        $this->redirect('@baza_uslug_usluga');
    }

    public function executeBatch(sfWebRequest $request)
    {
        $request->checkCSRFProtection();

        if(!$ids = $request->getParameter('ids'))
        {
            $this->getUser()->setFlash('error', 'You must at least select one item.');

            $this->redirect('@baza_uslug_usluga');
        }

        if(!$action = $request->getParameter('batch_action'))
        {
            $this->getUser()->setFlash('error', 'You must select an action to execute on the selected items.');

            $this->redirect('@baza_uslug_usluga');
        }

        if(!method_exists($this, $method = 'execute'.ucfirst($action)))
        {
            throw new InvalidArgumentException(sprintf('You must create a "%s" method for action "%s"', $method, $action));
        }

        if(!$this->getUser()->hasCredential($this->configuration->getCredentials($action)))
        {
            $this->forward(sfConfig::get('sf_secure_module'), sfConfig::get('sf_secure_action'));
        }

        $validator = new sfValidatorPropelChoiceMany(array('model' => 'BazaUslugUsluga'));
        try
        {
            // validate ids
            $ids = $validator->clean($ids);

            // execute batch
            $this->$method($request);
        }
        catch (sfValidatorError $e)
        {
            $this->getUser()->setFlash('error', 'A problem occurs when deleting the selected items as some items do not exist anymore.');
        }

        $this->redirect('@baza_uslug_usluga');
    }

    protected function executeBatchDelete(sfWebRequest $request)
    {
        $ids = $request->getParameter('ids');

        $count = 0;
        foreach(BazaUslugUslugaPeer::retrieveByPks($ids) as $object)
        {
            $this->dispatcher->notify(new sfEvent($this, 'admin.delete_object', array('object' => $object)));

            $object->delete();
            if($object->isDeleted())
            {
                $count++;
            }
        }

        if($count >= count($ids))
        {
            $this->getUser()->setFlash('notice', 'The selected items have been deleted successfully.');
        }
        else
        {
            $this->getUser()->setFlash('error', 'A problem occurs when deleting the selected items.');
        }

        $this->redirect('@baza_uslug_usluga');
    }

    protected function executeBatchPublicate(sfWebRequest $request)
    {
        $ids = $request->getParameter('ids');

        $count = 0;
        foreach(BazaUslugUslugaPeer::retrieveByPks($ids) as $object)
        {
            $object->publicate();
            $count++;
        }

        if($count >= count($ids))
        {
            $this->getUser()->setFlash('notice', 'Wybrane usługi zostały opublikowane poprawnie');
        }
        else
        {
            $this->getUser()->setFlash('error', 'Wystąpił błąd podczas publikacji wybranych usług');
        }

        $this->redirect('@baza_uslug_usluga');
    }

    protected function executeBatchHide(sfWebRequest $request)
    {
        $ids = $request->getParameter('ids');

        $count = 0;
        foreach(BazaUslugUslugaPeer::retrieveByPks($ids) as $object)
        {
            $object->hide();
            $count++;
        }

        if($count >= count($ids))
        {
            $this->getUser()->setFlash('notice', 'Wybrane usługi zostały ukryte poprawnie');
        }
        else
        {
            $this->getUser()->setFlash('error', 'Wystąpił błąd podczas ukrywania wybranych usług');
        }

        $this->redirect('@baza_uslug_usluga');
    }

    protected function processForm(sfWebRequest $request, sfForm $form)
    {
        $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
        if($form->isValid())
        {
            $notice = $form->getObject()->isNew() ? 'The item was created successfully.' : 'The item was updated successfully.';

            $baza_uslug_usluga = $form->save();

            // tworzenie katalogu dla tego artykulu
            @mkdir(sfConfig::get('sf_upload_dir').'/baza_uslug/uslg_'.$baza_uslug_usluga->getId().'/', 0777, true);
        
            //Generowanie zajawki z usuwaniem niepotrzebnych tagow
            $dlugosc_zajawki = 255;
            $params = $request->getParameter($form->getName(), array());
            foreach(JezykTblPeer::getCulturesForModul('uslg') as $culture)
            {
                $i18n = $baza_uslug_usluga->getCurrentBazaUslugUslugaI18n($culture);

                //Ustawienie odpowiendich sciezek w tekscie
                //w TinyMCE.init() ustawione relative_urls: true wiec nie powinno byc zadnych problemow ze sciezkami
                //TinyMCE nie dorzuca poczatkowego slasha trzeba dodac recznie tak jak ponizej
                if($params[$culture]['opis'])
                    $i18n->setOpis(str_replace('"uploads/', '"/uploads/', $params[$culture]['opis']));

                $zajawka = trim(strip_tags($params[$culture]['zajawka']));
                $opis = $i18n->getOpis();

                //$zajawka = trim($baza_uslug_specjalista->getZajawka());
                if(empty($zajawka))
                {
                    $zajawka = Functions::generujSkrotTekstu($opis, $dlugosc_zajawki);
                    $i18n->setZajawka($zajawka);
                }
                else
                    $i18n->setZajawka($zajawka);

                $i18n->save();
            }

            $this->dispatcher->notify(new sfEvent($this, 'admin.save_object', array('object' => $baza_uslug_usluga)));

            if($request->hasParameter('_save_and_add'))
            {
                $this->getUser()->setFlash('notice', $notice.' You can add another one below.');

                $this->redirect('@baza_uslug_usluga_new');
            }
            else
            {
                $this->getUser()->setFlash('notice', $notice);

                $this->redirect(array('sf_route' => 'baza_uslug_usluga_edit', 'sf_subject' => $baza_uslug_usluga));
            }
        }
        else
        {
            $this->getUser()->setFlash('error', 'The item has not been saved due to some errors.', false);
        }
    }

    protected function getFilters()
    {
        return $this->getUser()->getAttribute('uslg_usluga.filters', $this->configuration->getFilterDefaults(), 'admin_module');
    }

    protected function setFilters(array $filters)
    {
        return $this->getUser()->setAttribute('uslg_usluga.filters', $filters, 'admin_module');
    }

    protected function getPager()
    {
        $pager = $this->configuration->getPager('BazaUslugUsluga');
        $pager->setCriteria($this->buildCriteria());
        $pager->setPage($this->getPage());
        $pager->setPeerMethod($this->configuration->getPeerMethod());
        $pager->setPeerCountMethod($this->configuration->getPeerCountMethod());
        $pager->init();

        return $pager;
    }

    protected function setPage($page)
    {
        $this->getUser()->setAttribute('uslg_usluga.page', $page, 'admin_module');
    }

    protected function getPage()
    {
        return $this->getUser()->getAttribute('uslg_usluga.page', 1, 'admin_module');
    }

    protected function buildCriteria()
    {
        if(is_null($this->filters))
        {
            $this->filters = $this->configuration->getFilterForm($this->getFilters());
        }

        $criteria = $this->filters->buildCriteria($this->getFilters());

        $this->addSortCriteria($criteria);

        $event = $this->dispatcher->filter(new sfEvent($this, 'admin.build_criteria'), $criteria);
        $criteria = $event->getReturnValue();

        return $criteria;
    }

    protected function addSortCriteria($criteria)
    {
        if(array(null, null) == ($sort = $this->getSort()))
        {
            return;
        }

        if($sort[0] == 'nazwa')
        {
            $culture = $this->getUser()->getCulture();
            $criteria->addJoin(BazaUslugUslugaPeer::ID, BazaUslugUslugaI18nPeer::ID, Criteria::LEFT_JOIN);
            $criteria->add(BazaUslugUslugaI18nPeer::CULTURE, $culture);
            if('asc' == $sort[1])
                $criteria->addAscendingOrderByColumn(BazaUslugUslugaI18nPeer::NAZWA);
            else
                $criteria->addDescendingOrderByColumn(BazaUslugUslugaI18nPeer::NAZWA);
           
            return;
        }

        $column = BazaUslugUslugaPeer::translateFieldName($sort[0], BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_COLNAME);
        if('asc' == $sort[1])
        {
            $criteria->addAscendingOrderByColumn($column);
        }
        else
        {
            $criteria->addDescendingOrderByColumn($column);
        }
    }

    protected function getSort()
    {
        if(!is_null($sort = $this->getUser()->getAttribute('uslg_usluga.sort', null, 'admin_module')))
        {
            return $sort;
        }

        $this->setSort($this->configuration->getDefaultSort());

        return $this->getUser()->getAttribute('uslg_usluga.sort', null, 'admin_module');
    }

    protected function setSort(array $sort)
    {
        if(!is_null($sort[0]) && is_null($sort[1]))
        {
            $sort[1] = 'asc';
        }

        $this->getUser()->setAttribute('uslg_usluga.sort', $sort, 'admin_module');
    }

    protected function isValidSortColumn($column)
    {
        return in_array($column, BasePeer::getFieldnames('BazaUslugUsluga', BasePeer::TYPE_FIELDNAME)) || $column == 'nazwa';
    }

}
