<?php

/**
 * baza_uslug actions.
 *
 * @package    sam3
 * @subpackage baza_uslug
 * @author     Your name here
 */
class baza_uslugActions extends sfActions
{

    public function preExecute()
    {
        $culture = $this->getUser()->getCulture();
        $enabled = ModulPeer::getEnabled($culture);
        $this->forward404Unless(in_array('uslg', $enabled), 'Moduł `Baza usług` nie jest aktywny.');
    }

    /**
     * widok startowy modulu
     * @param       sfWebRequest $request
     * @author      Tomasz Glowinski, 2014
     */
    public function executeIndex(sfWebRequest $request)
    {
        $this->getUser()->setAttribute('search_params', array(), '/baza_uslug');
        
        $typ_id = $request->getParameter('typ_id', null);
        $this->baza_uslug_kategoria_list = BazaUslugKategoriaPeer::getFilteredList($typ_id);

        $this->types = sfConfig::get('app_uslg_types');
        if($typ_id)
            $this->typ_id = array($typ_id, $this->types[$typ_id]);
    }

    /**
     * widok listy kategorii
     * @param sfWebRequest $request
     * @author      Tomasz Glowinski, 2014
     */
    public function executeListaKategorii(sfWebRequest $request)
    {
        $this->getUser()->setAttribute('search_params', array(), '/baza_uslug');
        
        $typ_id = $request->getParameter('typ_id', null);
        $this->baza_uslug_kategoria_list = BazaUslugKategoriaPeer::getFilteredList($typ_id);

        $this->types = sfConfig::get('app_uslg_types');
        if($typ_id)
            $this->typ_id = array($typ_id, $this->types[$typ_id]);
    }

    /**
     * widok listy specjalistow
     * @param sfWebRequest $request
     * @author      Tomasz Glowinski, 2014
     */
    public function executeListaSpecjalistow(sfWebRequest $request)
    {
        $this->getUser()->setAttribute('search_params', array(), '/baza_uslug');
        
        $typ_id = $request->getParameter('typ_id', null);
        $this->baza_uslug_specjalista_list = BazaUslugSpecjalistaPeer::getFilteredList($typ_id);

        $this->types = sfConfig::get('app_uslg_types');
        if($typ_id)
            $this->typ_id = array($typ_id, $this->types[$typ_id]);
    }

    /**
     * widok listy uslug
     * @param sfWebRequest $request
     * @author      Tomasz Glowinski, 2014
     */
    public function executeListaUslug(sfWebRequest $request)
    {
        $this->getUser()->setAttribute('search_params', array(), '/baza_uslug');
        
        $typ_id = $request->getParameter('typ_id', null);
        $this->baza_uslug_usluga_list = BazaUslugUslugaPeer::getFilteredList($typ_id);

        $this->types = sfConfig::get('app_uslg_types');
        if($typ_id)
            $this->typ_id = array($typ_id, $this->types[$typ_id]);
    }

    /**
     * widok tresci kategorii
     * @param sfWebRequest $request
     * @author      Tomasz Glowinski, 2014
     */
    public function executeShowKategoria(sfWebRequest $request)
    {
        $id = $request->getParameter('id', null);
        $this->forward404Unless($id, 'Nie określono kategorii');
        $this->baza_uslug_kategoria = BazaUslugKategoriaPeer::retrieveByPK($id);
        $this->forward404Unless($id, 'Nie ma takiej kategorii');
        $request->setParameter('typ_id', $this->baza_uslug_kategoria->getTyp());
        $request->setParameter('kat_id', $this->baza_uslug_kategoria->getId());
        
        $this->types = sfConfig::get('app_uslg_types');
    }

    /**
     * widok tresci specjalisty
     * @param sfWebRequest $request
     * @author      Tomasz Glowinski, 2014
     */
    public function executeShowSpecjalista(sfWebRequest $request)
    {
        $id = $request->getParameter('id', null);
        $this->forward404Unless($id, 'Nie określono specjalisty');
        $this->baza_uslug_specjalista = BazaUslugSpecjalistaPeer::retrieveByPK($id);
        $this->forward404Unless($this->baza_uslug_specjalista, 'Nie ma takiego specjalisty');
        $request->setParameter('spec_id', $this->baza_uslug_specjalista->getId());
        
        $this->types = sfConfig::get('app_uslg_types');
    }

    /**
     * widok tresci Usluga
     * @param sfWebRequest $request
     * @author      Tomasz Glowinski, 2014
     */
    public function executeShowUsluga(sfWebRequest $request)
    {
        $id = $request->getParameter('id', null);
        $this->forward404Unless($id, 'Nie określono usługi');
        $this->baza_uslug_usluga = BazaUslugUslugaPeer::retrieveByPK($id);
        $this->forward404Unless($this->baza_uslug_usluga, 'Nie ma takiej usługi');
        $request->setParameter('uslg_id', $this->baza_uslug_usluga->getId());
        
        $this->types = sfConfig::get('app_uslg_types');
    }
    
    /**
     * widok wynikow wyszukiwania
     * @param sfWebRequest $request
     * @author      Tomasz Glowinski, 2014
     */
    public function executeSearch(sfWebRequest $request)
    {
        $this->types = sfConfig::get('app_uslg_types');
        
        $restrict = $this->restrict = $request->getParameter('restrict', null);
        
        switch ($restrict)
        {
            case 'kategoria':
                $this->wyszukiwarka = 'kategorii';
                $this->nav_label = 'Kategorie';
                break;
            
            case 'specjalista':
                $this->wyszukiwarka = 'specjalistow';
                $this->nav_label = 'Specjaliści';
                break;
            
            case 'usluga':
                $this->wyszukiwarka = 'uslug';
                $this->nav_label = 'Usługi';
                break;

            default:
                break;
        }        
        
        if($request->isMethod('post'))
        {
            $params = $request->getParameter('baza_uslug_szukaj', array());
            $this->forward404Unless($params, 'Błędnie określone kryteria wyszkiwania');
            
//            $form = new BazaUslugWyszukiwarkaForm($params);
//            if(!$form->isValid())
//            {
//                $this->getUser()->setFlash('error', 'Błędnie określone kryteria wyszukiwania.');
//                print_r('<pre>').print_r($form->getGlobalErrors()).print_r('</pre>');
//                exit();
//                $this->redirect('@uslg_search');
//            }
            
            if(array_key_exists('_csrf_token', $params))
                unset($params['_csrf_token']);
            
            $this->getUser()->setAttribute('search_params', $params, '/baza_uslug');
        }
        else
        {
            $params = $this->getUser()->getAttribute('search_params', array(), '/baza_uslug');
        }
        
        if(is_null($restrict) || $restrict == 'usluga')        
            $this->baza_uslug_usluga_list = BazaUslugUslugaPeer::getFilteredList(null, $params['kat'] ,$params['spec'], null, $params['fraza'], $params['usluga']);
        
        if(is_null($restrict) || $restrict == 'specjalista')        
            $this->baza_uslug_specjalista_list = BazaUslugSpecjalistaPeer::getFilteredList(null, $params['kat'] ,$params['spec'], null, $params['fraza'], $params['usluga']);
        
        if(is_null($restrict) || $restrict == 'kategoria')        
            $this->baza_uslug_kategoria_list = BazaUslugKategoriaPeer::getFilteredList(null, $params['kat'] ,$params['spec'], null, $params['fraza'], $params['usluga']);
    }
}
