<?php

/**
 * baza_uslug components.
 *
 * @package    sam3
 * @subpackage baza_uslug
 * @author     Your name here
 */
class baza_uslugComponents extends sfComponents
{
    
    public function executeNajnowsze(sfWebRequest $request)
    {        
        // limit
        if(!isset($this->limit))
            $this->limit = 5;
        
        // wyciagamy najnowsze uslugi
        $this->baza_list = BazaUslugUslugaPeer::getNajnowsze($this->limit);
        
        if (empty($this->baza_list))
            return sfView::NONE;
    }
        
    public function executeSpecialist(sfWebRequest $request)
    {        
        // limit
        if(!isset($this->limit))
            $this->limit = 5;
        
        // wyciagamy specialistów uslug
        $this->specialist = BazaUslugSpecjalistaPeer::getSpecialist($this->limit);
        
        if (empty($this->specialist))
            return sfView::NONE;
    }
    
    public function executeKategory(sfWebRequest $request)
    {        
        // limit
        if(!isset($this->limit))
            $this->limit = 5;
        
        // wyciagamy Kateogrie uslug
        $this->kategory = BazaUslugKategoriaPeer::getKategory($this->limit);
        
        if (empty($this->kategory))
            return sfView::NONE;
    }
        
    public function executeMenu(sfWebRequest $request)
    {
        $this->types = sfConfig::get('app_uslg_types');
        $this->mode_sel = $request->getParameter('restrict', null);
        
        // lista kategorii
        if($this->mode_sel == 'kategoria')
            $this->kat_structure = BazaUslugKategoriaPeer::getStructure();
        else
            $this->kat_structure = array();
        
        // lista uslug
        if($this->mode_sel == 'usluga')
            $this->uslg_structure = BazaUslugUslugaPeer::getFilteredList();
        else
            $this->uslg_structure = array();
        
        // lista specjalistow
        if($this->mode_sel == 'specjalista')
            $this->spec_structure = BazaUslugSpecjalistaPeer::getFilteredList();
        else
            $this->spec_structure = array();
        
        $this->typ_sel = $request->getParameter('typ_id', null);
        $this->kat_sel = $request->getParameter('kat_id', null);
        $this->uslg_sel = $request->getParameter('uslg_id', null);
        $this->spec_sel = $request->getParameter('spec_id', null);
    }
    
    public function executePowiazane_uslugi(sfWebRequest $request)
    {
        if(!empty($this->typ_id))
            $typ_id = $this->typ_id;
        else
            $typ_id = $request->getParameter('typ_id', null);
        
        if(!empty($this->kat_id))
            $kat_id = $this->kat_id;
        else
            $kat_id = $request->getParameter('kat_id', null);
        
        if(!empty($this->spec_id))
            $spec_id = $this->spec_id;
        else
            $spec_id = $request->getParameter('spec_id', null);
        
        $this->list = BazaUslugUslugaPeer::getFilteredList($typ_id, $kat_id, $spec_id);  
        
        if (empty($this->list))
            return sfView::NONE;
    }
    
    public function executePowiazani_specjalisci(sfWebRequest $request)
    {
        if(!empty($this->typ_id))
            $typ_id = $this->typ_id;
        else
            $typ_id = $request->getParameter('typ_id', null);
        
        if(!empty($this->kat_id))
            $kat_id = $this->kat_id;
        else
            $kat_id = $request->getParameter('kat_id', null);
        
        if(!empty($this->uslg_id))
            $uslg_id = $this->uslg_id;
        else
            $uslg_id = $request->getParameter('usluga_id', null);
        
        $this->list = BazaUslugSpecjalistaPeer::getFilteredList($typ_id, $kat_id, null, $uslg_id);    
                
        if (empty($this->list))
            return sfView::NONE;
    }
    
    public function executePowiazane_kategorie(sfWebRequest $request)
    {
        if(!empty($this->typ_id))
            $typ_id = $this->typ_id;
        else
            $typ_id = $request->getParameter('typ_id', null);
        
        if(!empty($this->kat_id))
            $kat_id = $this->kat_id;
        else
            $kat_id = $request->getParameter('kat_id', null);
                
        if(!empty($this->spec_id))
            $spec_id = $this->spec_id;
        else
            $spec_id = $request->getParameter('spec_id', null);

        if(!empty($this->uslg_id))
            $uslg_id = $this->uslg_id;
        else
            $uslg_id = $request->getParameter('usluga_id', null);
        
        $this->list = BazaUslugKategoriaPeer::getFilteredList($typ_id, $kat_id, $spec_id, $uslg_id);    
        
        if (empty($this->list))
            return sfView::NONE;
    }
    
    public function executeWyszukiwarka(sfWebRequest $request)
    {
        $defaults = $this->getUser()->getAttribute('search_params', array(), '/baza_uslug');
        $this->form = new BazaUslugWyszukiwarkaForm($defaults);
    }
    
    public function executeWyszukiwarka_kategorii(sfWebRequest $request)
    {
        $defaults = $this->getUser()->getAttribute('search_params', array(), '/baza_uslug');
        $this->form = new BazaUslugWyszukiwarkaForm($defaults);
    }
    
    public function executeWyszukiwarka_specjalistow(sfWebRequest $request)
    {
        $defaults = $this->getUser()->getAttribute('search_params', array(), '/baza_uslug');
        $this->form = new BazaUslugWyszukiwarkaForm($defaults);
    }
    
    public function executeWyszukiwarka_uslug(sfWebRequest $request)
    {
        $defaults = $this->getUser()->getAttribute('search_params', array(), '/baza_uslug');
        $this->form = new BazaUslugWyszukiwarkaForm($defaults);
    }
}
