<?php
use_stylesheet('portal/mikroblog');

// [PRESET] title
$title = $baza_uslug_specjalista->getNazwa();

// [PRESET] alt
$alt = $baza_uslug_specjalista->getOpisGrafikiZajawki();

// [PRESET] grafika zajawki
$img_file = null;
$img_size = 'normal';
{
    $sizes = UstawieniePeer::getProperties('graf_config_'.$img_size);
    $prefix = $img_size.'_';
    $imgstyle = 'max-width: '.$sizes['x'] . 'px';
    $zaj_file = sfConfig::get('sf_upload_dir').'/baza_uslug/spec_'.$baza_uslug_specjalista->getId().'/thumbnails/'.$prefix.$baza_uslug_specjalista->getGrafikaZajawki();
    if(is_file($zaj_file))
        $img_file = image_tag(str_replace(sfConfig::get('sf_upload_dir'), $sf_request->getRelativeUrlRoot().'/uploads', $zaj_file), array('alt' => $alt, 'style' => $imgstyle));
    else
        $img_file = image_tag('common/def_zaj_'.$img_size.'.png', array('alt' => $alt, 'style' => $imgstyle));
}

//slot('navigator');
$path = array(__(ModulPeer::getFromShort('uslg')->getNazwa()) => '@uslg_index', __('Specjaliści') => '@uslg_lista_specjalistow');
$path[$baza_uslug_specjalista->getNazwa()] = '@uslg_spec?id='.$baza_uslug_specjalista->getId().'&slug='.Functions::slugify($baza_uslug_specjalista->getNazwa());
//include_partial('Common/nawigator', array('path' => $path));
//end_slot();
$_SESSION['navigator_path'] = serialize($path);

//include_component('baza_uslug', 'wyszukiwarka_specjalistow');
// *****************************************************************************
?>

<article itemscope itemtype="http://schema.org/NewsArticle">

    <meta itemprop="description" content="<?php echo strip_tags($baza_uslug_specjalista->getZajawka()); ?>" />
    <meta itemprop="datePublished" content="<?php echo $baza_uslug_specjalista->getCreatedAt('c'); ?>" />

    <header>
        <h2 class="title" itemprop="headline">
            <?php
            echo $baza_uslug_specjalista->getNazwa();

            /* lektor audio */
            if(!empty($audio_path))
                include_partial('Common/mp3', array('audio_path' => $audio_path));
            ?>
        </h2>
    </header>

    <?php //Functions::renderInfo($baza_uslug_specjalista, 'getCreatedAt', ''); ?>

    <section class="flex">
        <?php if($img_file): ?>        
            <span class="grafika_tresc" style="max-width:<?php echo $sizes['x'].'px'; ?>">
                <?php
                //grafika zajawki strony               
                echo link_to($img_file, str_replace(array($prefix, sfConfig::get('sf_upload_dir'), '/thumbnails'), array('', $sf_request->getRelativeUrlRoot().'/uploads', ''), $zaj_file), array('class' => 'fancybox', 'rel' => 'galeria'));
                ?>
            </span>
        <?php endif; ?>

        <div style="width: calc(100% - <?php echo 15 + intval($sizes['x']); ?>px);">
            <?php echo $baza_uslug_specjalista->getDetails(); ?>
        </div>
    </section>


    <div class="tresc" itemprop="articleBody">        
        <?php echo $baza_uslug_specjalista->getOpis(); ?>
    </div>

    <footer class="bottom">
        <?php include_partial('Common/microblog', array('tytul' => $baza_uslug_specjalista->getNazwa())); ?>
        <?php include_partial('baza_uslug/actions', array('title' => $baza_uslug_specjalista->getNazwa())); ?>
        <div class="cl"></div>
    </footer>
</div>

<?php include_component('baza_uslug', 'powiazane_kategorie', array('spec_id' => $baza_uslug_specjalista->getId(), 'title' => 'Kategorie')); ?>
<?php include_component('baza_uslug', 'powiazane_uslugi', array('spec_id' => $baza_uslug_specjalista->getId(), 'title' => 'Usługi')); ?>

