<?php

/**
 * BazaUslugSpecjalista filter form.
 *
 * @package    sam3
 * @subpackage filter
 * @author     Your name here
 */
class BazaUslugSpecjalistaFormFilter extends BaseBazaUslugSpecjalistaFormFilter
{

    
    public function configure()
    {
        $this->widgetSchema['nazwa'] = new sfWidgetFormFilterInput(array('with_empty' => false), array('style' => 'width: 95px;'));
        $this->widgetSchema['status_id'] = new sfWidgetFormSelect(array('choices' => array(null => '', '0' => 'Ukryta', '1' => 'Opublikowana')), array('style' => 'width: 100px;'));
        $this->widgetSchema['updated_at'] = new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormInputDateTimeRich(array(), array('style' => 'width: 95px;')), 'to_date' => new sfWidgetFormInputDateTimeRich(array(), array('style' => 'width: 95px;')), 'with_empty' => false, 'template' => '%from_date% do %to_date%'));        
        $this->widgetSchema['portal_id'] = new sfWidgetFormInputHidden();
        
        $this->getWidgetSchema()->setDefault('portal_id', sfConfig::get('portal')->getId());
        
        $this->validatorSchema['nazwa'] = new sfValidatorPass(array('required' => false));   
        
        //$this->widgetSchema->setHelp('nazwa', 'Podaj fragment nazwy kategorii');
    }

    public function addNazwaColumnCriteria(Criteria $criteria, $field, $values)
    {
        if(!is_array($values))
        {
            $values = array($values);
        }

        if(!count($values))
        {
            return;
        }

        $criteria->addJoin(BazaUslugSpecjalistaPeer::ID, BazaUslugSpecjalistaI18nPeer::ID, Criteria::LEFT_JOIN);
        $criteria->add(BazaUslugSpecjalistaI18nPeer::CULTURE, sfContext::getInstance()->getUser()->getCulture());

        $value = array_pop($values);
        $criterion = $criteria->getNewCriterion(BazaUslugSpecjalistaI18nPeer::NAZWA, '%'.$value.'%', Criteria::LIKE);

        foreach($values as $value)
        {
            $criterion->addOr($criteria->getNewCriterion(BazaUslugSpecjalistaI18nPeer::NAZWA, '%'.$value.'%', Criteria::LIKE));
        }

        $criteria->add($criterion);
    }

    public function getFields()
    {
        return parent::getFields() + array('nazwa' => 'Nazwa');
    }

}
