<?php

require_once(sfConfig::get('sf_lib_dir').'/filter/base/BaseFormFilterPropel.class.php');

/**
 * BazaUslugSpecjalista filter form base class.
 *
 * @package    sam3
 * @subpackage filter
 * @author     Your name here
 */
class BaseBazaUslugSpecjalistaFormFilter extends BaseFormFilterPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'kolejnosc'                      => new sfWidgetFormFilterInput(),
      'status_id'                      => new sfWidgetFormPropelChoice(array('model' => 'AStatus', 'add_empty' => true)),
      'portal_id'                      => new sfWidgetFormPropelChoice(array('model' => 'Portal', 'add_empty' => true)),
      'grafika_zajawki'                => new sfWidgetFormFilterInput(),
      'prefix_grafiki_zajawki'         => new sfWidgetFormFilterInput(),
      'promowana'                      => new sfWidgetFormFilterInput(),
      'created_at'                     => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate(), 'with_empty' => true)),
      'updated_at'                     => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate(), 'with_empty' => true)),
      'baza_uslug_mapa_spec_kat_list'  => new sfWidgetFormPropelChoice(array('model' => 'BazaUslugKategoria', 'add_empty' => true)),
      'baza_uslug_mapa_uslg_spec_list' => new sfWidgetFormPropelChoice(array('model' => 'BazaUslugUsluga', 'add_empty' => true)),
    ));

    $this->setValidators(array(
      'kolejnosc'                      => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'status_id'                      => new sfValidatorPropelChoice(array('required' => false, 'model' => 'AStatus', 'column' => 'id')),
      'portal_id'                      => new sfValidatorPropelChoice(array('required' => false, 'model' => 'Portal', 'column' => 'id')),
      'grafika_zajawki'                => new sfValidatorPass(array('required' => false)),
      'prefix_grafiki_zajawki'         => new sfValidatorPass(array('required' => false)),
      'promowana'                      => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'created_at'                     => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDate(array('required' => false)), 'to_date' => new sfValidatorDate(array('required' => false)))),
      'updated_at'                     => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDate(array('required' => false)), 'to_date' => new sfValidatorDate(array('required' => false)))),
      'baza_uslug_mapa_spec_kat_list'  => new sfValidatorPropelChoice(array('model' => 'BazaUslugKategoria', 'required' => false)),
      'baza_uslug_mapa_uslg_spec_list' => new sfValidatorPropelChoice(array('model' => 'BazaUslugUsluga', 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('baza_uslug_specjalista_filters[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function addBazaUslugMapaSpecKatListColumnCriteria(Criteria $criteria, $field, $values)
  {
    if (!is_array($values))
    {
      $values = array($values);
    }

    if (!count($values))
    {
      return;
    }

    $criteria->addJoin(BazaUslugMapaSpecKatPeer::SPEC_ID, BazaUslugSpecjalistaPeer::ID);

    $value = array_pop($values);
    $criterion = $criteria->getNewCriterion(BazaUslugMapaSpecKatPeer::KAT_ID, $value);

    foreach ($values as $value)
    {
      $criterion->addOr($criteria->getNewCriterion(BazaUslugMapaSpecKatPeer::KAT_ID, $value));
    }

    $criteria->add($criterion);
  }

  public function addBazaUslugMapaUslgSpecListColumnCriteria(Criteria $criteria, $field, $values)
  {
    if (!is_array($values))
    {
      $values = array($values);
    }

    if (!count($values))
    {
      return;
    }

    $criteria->addJoin(BazaUslugMapaUslgSpecPeer::SPEC_ID, BazaUslugSpecjalistaPeer::ID);

    $value = array_pop($values);
    $criterion = $criteria->getNewCriterion(BazaUslugMapaUslgSpecPeer::USLG_ID, $value);

    foreach ($values as $value)
    {
      $criterion->addOr($criteria->getNewCriterion(BazaUslugMapaUslgSpecPeer::USLG_ID, $value));
    }

    $criteria->add($criterion);
  }

  public function getModelName()
  {
    return 'BazaUslugSpecjalista';
  }

  public function getFields()
  {
    return array(
      'id'                             => 'Number',
      'kolejnosc'                      => 'Number',
      'status_id'                      => 'ForeignKey',
      'portal_id'                      => 'ForeignKey',
      'grafika_zajawki'                => 'Text',
      'prefix_grafiki_zajawki'         => 'Text',
      'promowana'                      => 'Number',
      'created_at'                     => 'Date',
      'updated_at'                     => 'Date',
      'baza_uslug_mapa_spec_kat_list'  => 'ManyKey',
      'baza_uslug_mapa_uslg_spec_list' => 'ManyKey',
    );
  }
}
