<?php

/**
 * BazaUslugSpecjalista form.
 *
 * @package    sam3
 * @subpackage form
 * @author     Your name here
 */
class BazaUslugSpecjalistaForm extends BaseBazaUslugSpecjalistaForm
{

    public function configure()
    {
        $this->widgetSchema['id'] = new sfWidgetFormInputHidden();
        $this->widgetSchema['kolejnosc'] = new sfWidgetFormInputHidden();
        $this->widgetSchema['status_id'] = new sfWidgetFormSelectRadio(array('choices' => array('0' => 'Nie', '1' => 'Tak')));
        $this->widgetSchema['promowana'] = new sfWidgetFormInputHidden(); //sfWidgetFormSelectRadio(array('choices' => array('0' => 'Nie', '1' => 'Tak')));
        

        $gfx = $this->getObject()->getGrafikaZajawki();
        $base_path = sfContext::getInstance()->getRequest()->getRelativeUrlRoot();
        
        if(!$this->getObject()->getId())
            unset($this['grafika_zajawki']);
        else
            $this->widgetSchema['grafika_zajawki'] = new sfWidgetFormInputFileEditable(array(
                'label' => 'Grafika zajawki',
                'delete_label' => 'Usuń grafikę zajawki',
                'file_src' => (!$this->isNew() && !empty($gfx)) ? $base_path.'/uploads/baza_uslug/spec_'.$this->getObject()->getId().'/thumbnails/thumb_'.$gfx : $base_path.'/images/admin/no_image.jpg',
                'is_image' => true,
                'edit_mode' => !$this->isNew(),
                'template' => '<div style="margin: 0px 0px 4px 0px;">%file%</div><div style="margin: 0px 0px 4px 0px;">%input%</div><div id="label_delete_graf">%delete% %delete_label%</div>',
            ));
        $this->widgetSchema['portal_id'] = new sfWidgetFormInputHidden();
        $this->widgetSchema['created_at'] = new sfWidgetFormInputHidden();
        $this->widgetSchema['updated_at'] = new sfWidgetFormInputHidden();
        $this->widgetSchema['baza_uslug_mapa_spec_kat_list'] = new sfWidgetFormPropelChoiceMany(array('model' => 'BazaUslugKategoria'));
        $this->widgetSchema['baza_uslug_mapa_uslg_spec_list'] = new sfWidgetFormPropelChoiceMany(array('model' => 'BazaUslugUsluga'));

        $this->getWidgetSchema()->setDefault('kolejnosc', 0);
        $this->getWidgetSchema()->setDefault('status_id', 1);
        $this->getWidgetSchema()->setDefault('portal_id', sfConfig::get('portal')->getId());

        $this->setValidator('grafika_zajawki', new ciValidatorFile(array('mime_types' => 'web_images', 'required' => false, 'path' => $base_path.'/uploads/baza_uslug/spec_'.$this->getObject()->getId())));
        $this->setValidator('grafika_zajawki_delete', new sfValidatorPass());
        
        $this->getValidatorSchema()->setOption('allow_extra_fields', true);

        $cultures = JezykTblPeer::getCulturesForModul('uslg');
        $this->embedI18n($cultures);
    }

}
