<?php

/**
 * BazaUslugKategoria form.
 *
 * @package    sam3
 * @subpackage form
 * @author     Your name here
 */
class BazaUslugWyszukiwarkaForm extends sfForm
{

    public function configure()
    {
        // preset **************************************************************
        // kategorie
        $structure = BazaUslugKategoriaPeer::getStructure();
        $types = sfConfig::get('app_uslg_types');
        $kat_choices = array(null => '- wybierz kategorię z listy -');
        foreach($structure as $typ_id => $list)
        {
            $kat_choices[$types[$typ_id]] = array();
            foreach($list as $kat)
                $kat_choices[$types[$typ_id]][$kat->getId()] = $kat->getNazwa();
        }

        // specjalisci
        $specjalisci = BazaUslugSpecjalistaPeer::getFilteredList();
        $spec_choices = array(null => '- wybierz specjalistę z listy -');
        foreach($specjalisci as $spec)
            $spec_choices[$spec->getId()] = $spec->getNazwa();

        // widget **************************************************************
        $this->setWidgets(array(
            'fraza' => new sfWidgetFormInput(array(), array('style' => 'width: 100%; padding: 5px; box-sizing: border-box; margin: 5px 0;')),
            'usluga' => new sfWidgetFormInput(array(), array('style' => 'width: 100%; padding: 5px; box-sizing: border-box; margin: 5px 0;')),
            'kat' => new sfWidgetFormSelect(array('choices' => $kat_choices), array('style' => 'width: 100%; padding: 5px; box-sizing: border-box; margin: 5px 0;')),
            'spec' => new sfWidgetFormSelect(array('choices' => $spec_choices), array('style' => 'width: 100%; padding: 5px; box-sizing: border-box; margin: 5px 0;')),
        ));

        $this->widgetSchema->setLabels(array(
            'fraza' => 'Szukana fraza',
            'usluga' => 'Usługa',
            'kat' => 'Kategoria',
            'spec' => 'Specjalista',
        ));
        
        $this->widgetSchema->setHelps(array(
            'fraza' => 'Przeszukaj całą bazę informacji usług pod kątem interesującej cię frazy',
            'usluga' => 'Wyszukaj usługi po nazwie lub jej części',
            'kat' => 'Wybierz jedną z kategorii by zobaczyć więcej informacji',
            'spec' => 'Wybierz jednego z naszych specjalistów',
        ));
        
        $this->widgetSchema->setNameFormat('baza_uslug_szukaj[%s]');

        // validator ***********************************************************

        $this->setValidators(array(
            'fraza' => new sfValidatorString(),
            'usluga' => new sfValidatorString(),
            'kat' => new sfValidatorChoice(array('choices' => array_keys($kat_choices))),
            'spec' => new sfValidatorChoice(array('choices' => array_keys($spec_choices))),
        ));
        
        $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);
    }

}
