<?php

/**
 * BazaUslugKategoria form base class.
 *
 * @package    sam3
 * @subpackage form
 * @author     Your name here
 */
class BaseBazaUslugKategoriaForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'                            => new sfWidgetFormInputHidden(),
      'kolejnosc'                     => new sfWidgetFormInput(),
      'status_id'                     => new sfWidgetFormPropelChoice(array('model' => 'AStatus', 'add_empty' => false)),
      'portal_id'                     => new sfWidgetFormPropelChoice(array('model' => 'Portal', 'add_empty' => false)),
      'typ'                           => new sfWidgetFormInput(),
      'created_at'                    => new sfWidgetFormDateTime(),
      'updated_at'                    => new sfWidgetFormDateTime(),
      'baza_uslug_mapa_spec_kat_list' => new sfWidgetFormPropelChoiceMany(array('model' => 'BazaUslugSpecjalista')),
      'baza_uslug_mapa_uslg_kat_list' => new sfWidgetFormPropelChoiceMany(array('model' => 'BazaUslugUsluga')),
    ));

    $this->setValidators(array(
      'id'                            => new sfValidatorPropelChoice(array('model' => 'BazaUslugKategoria', 'column' => 'id', 'required' => false)),
      'kolejnosc'                     => new sfValidatorInteger(array('required' => false)),
      'status_id'                     => new sfValidatorPropelChoice(array('model' => 'AStatus', 'column' => 'id')),
      'portal_id'                     => new sfValidatorPropelChoice(array('model' => 'Portal', 'column' => 'id')),
      'typ'                           => new sfValidatorInteger(array('required' => false)),
      'created_at'                    => new sfValidatorDateTime(array('required' => false)),
      'updated_at'                    => new sfValidatorDateTime(array('required' => false)),
      'baza_uslug_mapa_spec_kat_list' => new sfValidatorPropelChoiceMany(array('model' => 'BazaUslugSpecjalista', 'required' => false)),
      'baza_uslug_mapa_uslg_kat_list' => new sfValidatorPropelChoiceMany(array('model' => 'BazaUslugUsluga', 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('baza_uslug_kategoria[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'BazaUslugKategoria';
  }

  public function getI18nModelName()
  {
    return 'BazaUslugKategoriaI18n';
  }

  public function getI18nFormClass()
  {
    return 'BazaUslugKategoriaI18nForm';
  }

  public function updateDefaultsFromObject()
  {
    parent::updateDefaultsFromObject();

    if (isset($this->widgetSchema['baza_uslug_mapa_spec_kat_list']))
    {
      $values = array();
      foreach ($this->object->getBazaUslugMapaSpecKats() as $obj)
      {
        $values[] = $obj->getSpecId();
      }

      $this->setDefault('baza_uslug_mapa_spec_kat_list', $values);
    }

    if (isset($this->widgetSchema['baza_uslug_mapa_uslg_kat_list']))
    {
      $values = array();
      foreach ($this->object->getBazaUslugMapaUslgKats() as $obj)
      {
        $values[] = $obj->getUslgId();
      }

      $this->setDefault('baza_uslug_mapa_uslg_kat_list', $values);
    }

  }

  protected function doSave($con = null)
  {
    parent::doSave($con);

    $this->saveBazaUslugMapaSpecKatList($con);
    $this->saveBazaUslugMapaUslgKatList($con);
  }

  public function saveBazaUslugMapaSpecKatList($con = null)
  {
    if (!$this->isValid())
    {
      throw $this->getErrorSchema();
    }

    if (!isset($this->widgetSchema['baza_uslug_mapa_spec_kat_list']))
    {
      // somebody has unset this widget
      return;
    }

    if (is_null($con))
    {
      $con = $this->getConnection();
    }

    $c = new Criteria();
    $c->add(BazaUslugMapaSpecKatPeer::KAT_ID, $this->object->getPrimaryKey());
    BazaUslugMapaSpecKatPeer::doDelete($c, $con);

    $values = $this->getValue('baza_uslug_mapa_spec_kat_list');
    if (is_array($values))
    {
      foreach ($values as $value)
      {
        $obj = new BazaUslugMapaSpecKat();
        $obj->setKatId($this->object->getPrimaryKey());
        $obj->setSpecId($value);
        $obj->save();
      }
    }
  }

  public function saveBazaUslugMapaUslgKatList($con = null)
  {
    if (!$this->isValid())
    {
      throw $this->getErrorSchema();
    }

    if (!isset($this->widgetSchema['baza_uslug_mapa_uslg_kat_list']))
    {
      // somebody has unset this widget
      return;
    }

    if (is_null($con))
    {
      $con = $this->getConnection();
    }

    $c = new Criteria();
    $c->add(BazaUslugMapaUslgKatPeer::KAT_ID, $this->object->getPrimaryKey());
    BazaUslugMapaUslgKatPeer::doDelete($c, $con);

    $values = $this->getValue('baza_uslug_mapa_uslg_kat_list');
    if (is_array($values))
    {
      foreach ($values as $value)
      {
        $obj = new BazaUslugMapaUslgKat();
        $obj->setKatId($this->object->getPrimaryKey());
        $obj->setUslgId($value);
        $obj->save();
      }
    }
  }

}
