<?php

/**
 * BazaUslugSpecjalista form base class.
 *
 * @package    sam3
 * @subpackage form
 * @author     Your name here
 */
class BaseBazaUslugSpecjalistaForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'                             => new sfWidgetFormInputHidden(),
      'kolejnosc'                      => new sfWidgetFormInput(),
      'status_id'                      => new sfWidgetFormPropelChoice(array('model' => 'AStatus', 'add_empty' => false)),
      'portal_id'                      => new sfWidgetFormPropelChoice(array('model' => 'Portal', 'add_empty' => false)),
      'grafika_zajawki'                => new sfWidgetFormInput(),
      'prefix_grafiki_zajawki'         => new sfWidgetFormInput(),
      'promowana'                      => new sfWidgetFormInput(),
      'created_at'                     => new sfWidgetFormDateTime(),
      'updated_at'                     => new sfWidgetFormDateTime(),
      'baza_uslug_mapa_spec_kat_list'  => new sfWidgetFormPropelChoiceMany(array('model' => 'BazaUslugKategoria')),
      'baza_uslug_mapa_uslg_spec_list' => new sfWidgetFormPropelChoiceMany(array('model' => 'BazaUslugUsluga')),
    ));

    $this->setValidators(array(
      'id'                             => new sfValidatorPropelChoice(array('model' => 'BazaUslugSpecjalista', 'column' => 'id', 'required' => false)),
      'kolejnosc'                      => new sfValidatorInteger(array('required' => false)),
      'status_id'                      => new sfValidatorPropelChoice(array('model' => 'AStatus', 'column' => 'id')),
      'portal_id'                      => new sfValidatorPropelChoice(array('model' => 'Portal', 'column' => 'id')),
      'grafika_zajawki'                => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'prefix_grafiki_zajawki'         => new sfValidatorString(array('max_length' => 7, 'required' => false)),
      'promowana'                      => new sfValidatorInteger(),
      'created_at'                     => new sfValidatorDateTime(array('required' => false)),
      'updated_at'                     => new sfValidatorDateTime(array('required' => false)),
      'baza_uslug_mapa_spec_kat_list'  => new sfValidatorPropelChoiceMany(array('model' => 'BazaUslugKategoria', 'required' => false)),
      'baza_uslug_mapa_uslg_spec_list' => new sfValidatorPropelChoiceMany(array('model' => 'BazaUslugUsluga', 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('baza_uslug_specjalista[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'BazaUslugSpecjalista';
  }

  public function getI18nModelName()
  {
    return 'BazaUslugSpecjalistaI18n';
  }

  public function getI18nFormClass()
  {
    return 'BazaUslugSpecjalistaI18nForm';
  }

  public function updateDefaultsFromObject()
  {
    parent::updateDefaultsFromObject();

    if (isset($this->widgetSchema['baza_uslug_mapa_spec_kat_list']))
    {
      $values = array();
      foreach ($this->object->getBazaUslugMapaSpecKats() as $obj)
      {
        $values[] = $obj->getKatId();
      }

      $this->setDefault('baza_uslug_mapa_spec_kat_list', $values);
    }

    if (isset($this->widgetSchema['baza_uslug_mapa_uslg_spec_list']))
    {
      $values = array();
      foreach ($this->object->getBazaUslugMapaUslgSpecs() as $obj)
      {
        $values[] = $obj->getUslgId();
      }

      $this->setDefault('baza_uslug_mapa_uslg_spec_list', $values);
    }

  }

  protected function doSave($con = null)
  {
    parent::doSave($con);

    $this->saveBazaUslugMapaSpecKatList($con);
    $this->saveBazaUslugMapaUslgSpecList($con);
  }

  public function saveBazaUslugMapaSpecKatList($con = null)
  {
    if (!$this->isValid())
    {
      throw $this->getErrorSchema();
    }

    if (!isset($this->widgetSchema['baza_uslug_mapa_spec_kat_list']))
    {
      // somebody has unset this widget
      return;
    }

    if (is_null($con))
    {
      $con = $this->getConnection();
    }

    $c = new Criteria();
    $c->add(BazaUslugMapaSpecKatPeer::SPEC_ID, $this->object->getPrimaryKey());
    BazaUslugMapaSpecKatPeer::doDelete($c, $con);

    $values = $this->getValue('baza_uslug_mapa_spec_kat_list');
    if (is_array($values))
    {
      foreach ($values as $value)
      {
        $obj = new BazaUslugMapaSpecKat();
        $obj->setSpecId($this->object->getPrimaryKey());
        $obj->setKatId($value);
        $obj->save();
      }
    }
  }

  public function saveBazaUslugMapaUslgSpecList($con = null)
  {
    if (!$this->isValid())
    {
      throw $this->getErrorSchema();
    }

    if (!isset($this->widgetSchema['baza_uslug_mapa_uslg_spec_list']))
    {
      // somebody has unset this widget
      return;
    }

    if (is_null($con))
    {
      $con = $this->getConnection();
    }

    $c = new Criteria();
    $c->add(BazaUslugMapaUslgSpecPeer::SPEC_ID, $this->object->getPrimaryKey());
    BazaUslugMapaUslgSpecPeer::doDelete($c, $con);

    $values = $this->getValue('baza_uslug_mapa_uslg_spec_list');
    if (is_array($values))
    {
      foreach ($values as $value)
      {
        $obj = new BazaUslugMapaUslgSpec();
        $obj->setSpecId($this->object->getPrimaryKey());
        $obj->setUslgId($value);
        $obj->save();
      }
    }
  }

}
