<?php

class BazaUslugSpecjalista extends BaseBazaUslugSpecjalista
{

    public function __toString()
    {
        $culture = sfContext::getInstance()->getUser()->getCulture();
        return $this->getCurrentBazaUslugSpecjalistaI18n($culture)->getNazwa();
    }

    /**
     * metoda publikujaca tego specjaliste
     * @author      Tomasz Glowinski, 2014
     */
    public function publicate()
    {
        $this->setStatusId(1);
        $this->save();
    }

    /**
     * metoda usuwajaca z publikujacji tego specjaliste
     * @author      Tomasz Glowinski, 2014
     */
    public function hide()
    {
        $this->setStatusId(0);
        $this->save();
    }

    /**
     * metoda zwracajaca szczegolowe dane tego specjalisty w formie lewo-prawo
     * @param       string $date_format [opcjonalnie] format daty
     * @param       string $time_format [opcjonalnie] format czasu
     * @return      string kod HTML ze szczegolami tego specjalisty
     * @author      Tomasz Glowinski, 2016
     */
    public function getDetails($date_format = null, $time_format = null, $skip_name = false)
    {
        if(empty($date_format))
        {
            $date_format = sfConfig::get('app_date_full_format');
        }

        if(empty($time_format))
        {
            $time_format = 'G:i';
        }

        $occurance_info = array();
        $tmp = array();
        if(!$skip_name && $this->getTytul())
        {
            $tmp[] = trim($this->getTytul());
        }

        if(!$skip_name && $this->getNazwa())
        {
            $tmp[] = trim($this->getNazwa());
        }
        if(!empty($tmp))
        {
            $occurance_info[__('Imię, nazwisko, tytuł')] = implode(' ', $tmp);
        }

        if($this->getSpecjalizacja())
        {
            $occurance_info[__('Specjalizacja')] = $this->getSpecjalizacja();
        }

        $tmp = array();
        $maps = $this->getBazaUslugMapaSpecKatsJoinBazaUslugKategoria();
        foreach($maps as $map)
        {
            $tmp[] = $map->getBazaUslugKategoria()->getNazwa();
        }
        if(!empty($tmp))
        {
            $occurance_info[__('Pracuje w')] = implode(', ', $tmp);
        }
        
        $tmp = array();
        $maps = $this->getBazaUslugMapaUslgSpecsJoinBazaUslugUsluga();
        foreach($maps as $map)
        {
            $tmp[] = $map->getBazaUslugUsluga()->getNazwa();
        }
        if(!empty($tmp))
        {
            $occurance_info[__('Wykonuje')] = implode(', ', $tmp);
        }
        
        $occurance_info_txt = '';
        foreach($occurance_info as $key => $val)
        {
            $occurance_info_txt .= '<div class="box-iobiekt">';
            $occurance_info_txt .= '<div class="obiekt_typ">'.$key.'</div>';
            $occurance_info_txt .= '<div class="obiekt_dane">'.$val.'</div>';
            $occurance_info_txt .= '</div>';
        }

        return $occurance_info_txt;
    }

}