<?php



class BazaUslugSpecjalistaMapBuilder implements MapBuilder {

	
	const CLASS_NAME = 'lib.model.map.BazaUslugSpecjalistaMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap(BazaUslugSpecjalistaPeer::DATABASE_NAME);

		$tMap = $this->dbMap->addTable(BazaUslugSpecjalistaPeer::TABLE_NAME);
		$tMap->setPhpName('BazaUslugSpecjalista');
		$tMap->setClassname('BazaUslugSpecjalista');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'INTEGER', true, null);

		$tMap->addColumn('KOLEJNOSC', 'Kolejnosc', 'INTEGER', false, 11);

		$tMap->addForeignKey('STATUS_ID', 'StatusId', 'INTEGER', 'aktualnosc_status', 'ID', true, 11);

		$tMap->addForeignKey('PORTAL_ID', 'PortalId', 'INTEGER', 'portal', 'ID', true, 11);

		$tMap->addColumn('GRAFIKA_ZAJAWKI', 'GrafikaZajawki', 'VARCHAR', false, 255);

		$tMap->addColumn('PREFIX_GRAFIKI_ZAJAWKI', 'PrefixGrafikiZajawki', 'VARCHAR', false, 7);

		$tMap->addColumn('PROMOWANA', 'Promowana', 'TINYINT', true, 1);

		$tMap->addColumn('CREATED_AT', 'CreatedAt', 'TIMESTAMP', false, null);

		$tMap->addColumn('UPDATED_AT', 'UpdatedAt', 'TIMESTAMP', false, null);

	} 
} 