<?php


abstract class BaseBazaUslugMapaUslgSpec extends BaseObject  implements Persistent {


  const PEER = 'BazaUslugMapaUslgSpecPeer';

	
	protected static $peer;

	
	protected $uslg_id;

	
	protected $spec_id;

	
	protected $aBazaUslugUsluga;

	
	protected $aBazaUslugSpecjalista;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
	}

	
	public function getUslgId()
	{
		return $this->uslg_id;
	}

	
	public function getSpecId()
	{
		return $this->spec_id;
	}

	
	public function setUslgId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->uslg_id !== $v) {
			$this->uslg_id = $v;
			$this->modifiedColumns[] = BazaUslugMapaUslgSpecPeer::USLG_ID;
		}

		if ($this->aBazaUslugUsluga !== null && $this->aBazaUslugUsluga->getId() !== $v) {
			$this->aBazaUslugUsluga = null;
		}

		return $this;
	} 
	
	public function setSpecId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->spec_id !== $v) {
			$this->spec_id = $v;
			$this->modifiedColumns[] = BazaUslugMapaUslgSpecPeer::SPEC_ID;
		}

		if ($this->aBazaUslugSpecjalista !== null && $this->aBazaUslugSpecjalista->getId() !== $v) {
			$this->aBazaUslugSpecjalista = null;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array())) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->uslg_id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->spec_id = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 2; 
		} catch (Exception $e) {
			throw new PropelException("Error populating BazaUslugMapaUslgSpec object", $e);
		}
	}

	
	public function ensureConsistency()
	{

		if ($this->aBazaUslugUsluga !== null && $this->uslg_id !== $this->aBazaUslugUsluga->getId()) {
			$this->aBazaUslugUsluga = null;
		}
		if ($this->aBazaUslugSpecjalista !== null && $this->spec_id !== $this->aBazaUslugSpecjalista->getId()) {
			$this->aBazaUslugSpecjalista = null;
		}
	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(BazaUslugMapaUslgSpecPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = BazaUslugMapaUslgSpecPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->aBazaUslugUsluga = null;
			$this->aBazaUslugSpecjalista = null;
		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(BazaUslugMapaUslgSpecPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			BazaUslugMapaUslgSpecPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(BazaUslugMapaUslgSpecPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			BazaUslugMapaUslgSpecPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

												
			if ($this->aBazaUslugUsluga !== null) {
				if ($this->aBazaUslugUsluga->isModified() || ($this->aBazaUslugUsluga->getCulture() && $this->aBazaUslugUsluga->getCurrentBazaUslugUslugaI18n()->isModified()) || $this->aBazaUslugUsluga->isNew()) {
					$affectedRows += $this->aBazaUslugUsluga->save($con);
				}
				$this->setBazaUslugUsluga($this->aBazaUslugUsluga);
			}

			if ($this->aBazaUslugSpecjalista !== null) {
				if ($this->aBazaUslugSpecjalista->isModified() || ($this->aBazaUslugSpecjalista->getCulture() && $this->aBazaUslugSpecjalista->getCurrentBazaUslugSpecjalistaI18n()->isModified()) || $this->aBazaUslugSpecjalista->isNew()) {
					$affectedRows += $this->aBazaUslugSpecjalista->save($con);
				}
				$this->setBazaUslugSpecjalista($this->aBazaUslugSpecjalista);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = BazaUslugMapaUslgSpecPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setNew(false);
				} else {
					$affectedRows += BazaUslugMapaUslgSpecPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aBazaUslugUsluga !== null) {
				if (!$this->aBazaUslugUsluga->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aBazaUslugUsluga->getValidationFailures());
				}
			}

			if ($this->aBazaUslugSpecjalista !== null) {
				if (!$this->aBazaUslugSpecjalista->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aBazaUslugSpecjalista->getValidationFailures());
				}
			}


			if (($retval = BazaUslugMapaUslgSpecPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = BazaUslugMapaUslgSpecPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getUslgId();
				break;
			case 1:
				return $this->getSpecId();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = BazaUslugMapaUslgSpecPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getUslgId(),
			$keys[1] => $this->getSpecId(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = BazaUslugMapaUslgSpecPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setUslgId($value);
				break;
			case 1:
				$this->setSpecId($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = BazaUslugMapaUslgSpecPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setUslgId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setSpecId($arr[$keys[1]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(BazaUslugMapaUslgSpecPeer::DATABASE_NAME);

		if ($this->isColumnModified(BazaUslugMapaUslgSpecPeer::USLG_ID)) $criteria->add(BazaUslugMapaUslgSpecPeer::USLG_ID, $this->uslg_id);
		if ($this->isColumnModified(BazaUslugMapaUslgSpecPeer::SPEC_ID)) $criteria->add(BazaUslugMapaUslgSpecPeer::SPEC_ID, $this->spec_id);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(BazaUslugMapaUslgSpecPeer::DATABASE_NAME);

		$criteria->add(BazaUslugMapaUslgSpecPeer::USLG_ID, $this->uslg_id);
		$criteria->add(BazaUslugMapaUslgSpecPeer::SPEC_ID, $this->spec_id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		$pks = array();

		$pks[0] = $this->getUslgId();

		$pks[1] = $this->getSpecId();

		return $pks;
	}

	
	public function setPrimaryKey($keys)
	{

		$this->setUslgId($keys[0]);

		$this->setSpecId($keys[1]);

	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setUslgId($this->uslg_id);

		$copyObj->setSpecId($this->spec_id);


		$copyObj->setNew(true);

	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new BazaUslugMapaUslgSpecPeer();
		}
		return self::$peer;
	}

	
	public function setBazaUslugUsluga(BazaUslugUsluga $v = null)
	{
		if ($v === null) {
			$this->setUslgId(NULL);
		} else {
			$this->setUslgId($v->getId());
		}

		$this->aBazaUslugUsluga = $v;

						if ($v !== null) {
			$v->addBazaUslugMapaUslgSpec($this);
		}

		return $this;
	}


	
	public function getBazaUslugUsluga(PropelPDO $con = null)
	{
		if ($this->aBazaUslugUsluga === null && ($this->uslg_id !== null)) {
			$c = new Criteria(BazaUslugUslugaPeer::DATABASE_NAME);
			$c->add(BazaUslugUslugaPeer::ID, $this->uslg_id);
			$this->aBazaUslugUsluga = BazaUslugUslugaPeer::doSelectOne($c, $con);
			
		}
		return $this->aBazaUslugUsluga;
	}

	
	public function setBazaUslugSpecjalista(BazaUslugSpecjalista $v = null)
	{
		if ($v === null) {
			$this->setSpecId(NULL);
		} else {
			$this->setSpecId($v->getId());
		}

		$this->aBazaUslugSpecjalista = $v;

						if ($v !== null) {
			$v->addBazaUslugMapaUslgSpec($this);
		}

		return $this;
	}


	
	public function getBazaUslugSpecjalista(PropelPDO $con = null)
	{
		if ($this->aBazaUslugSpecjalista === null && ($this->spec_id !== null)) {
			$c = new Criteria(BazaUslugSpecjalistaPeer::DATABASE_NAME);
			$c->add(BazaUslugSpecjalistaPeer::ID, $this->spec_id);
			$this->aBazaUslugSpecjalista = BazaUslugSpecjalistaPeer::doSelectOne($c, $con);
			
		}
		return $this->aBazaUslugSpecjalista;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
		} 
			$this->aBazaUslugUsluga = null;
			$this->aBazaUslugSpecjalista = null;
	}

} 